﻿define([
    // dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    // epi
    "epi-cms/component/Media",
], function (
    declare,
    lang,
    aspect,

    mediaComponent,
) {
    return declare("widen-dam-connector/AssetsViewer", [mediaComponent], {

        postCreate: function () {
            this.inherited(arguments);

            this.own(aspect.around(this.model, "_createListSearchQuery",
                lang.hitch(this.model, function () {
                    return function (searchText) {
                        var currentFolderRef = "";

                        if (this.selectedTreeItems && this.selectedTreeItems.length > 0)
                            currentFolderRef = this.selectedTreeItems[0].contentLink;

                        return {
                            queryText: searchText,
                            query: "searchwidenassets",
                            allLanguages: this.showAllLanguages,
                            contentSearchAreas: this.get("searchArea"),
                            searchRoots: this.get("searchRoots"),
                            maxResults: 1000,
                            filterDeleted: true,
                            currentFolderRef: currentFolderRef
                        };
                    };
                })));

            // disables folder refresh when editing an asset
            this.own(aspect.around(this.model, "selectItemsByContentReference",
                lang.hitch(this.model, function () {
                    return function () {
                        return; 
                    };
                })));
        },

        startup: function () {
            this.inherited(arguments);
        },
    });
});