﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",

    "epi/dependency",
    "epi/_Module",
    "epi-cms/command/EditImage",
], function (
    declare,
    lang,
    aspect,

    dependency,
    _Module,
    EditImage
) {
    return declare([_Module], {
        initialize: function () {
            this.inherited(arguments);

            var registry = dependency.resolve("epi.storeregistry");
            var light = registry.get("epi.cms.content.light");

            aspect.around(light,
                "refresh",
                lang.hitch(light,
                    function (originalMethod) {
                        return function () {
                            // we do not allow epi.cms.content.light registry to be refreshed if the object is Widen Element 
                            var isWidenContent = arguments[0].endsWith("__widen-assets");
                            if (!isWidenContent)
                                return originalMethod.apply(this, arguments);

                            return null;
                        };
                    }));

            //Removed command to open Widen Images in Image Editor
            var original = EditImage.prototype._onModelChange;
            EditImage.prototype._onModelChange = function () {
                original.apply(this, arguments);
                var target = this._getSingleSelectionData();
                if (target) {
                    if (target.contentLink.endsWith('__widen-assets')) {
                        this.set("isAvailable", false);
                        this.set("canExecute", false);
                    }
                }
            }
        }
    });
});